(*==========================================================================
  APOLLO.PAS - TApollo Component Stub File for Apollo 6.1

  Copyright 1999-2002 Vista Software
  Last Updated: 10-22-2002

	NOTE: The TApollo component is simply a stub that has absolutely no functionality. 
				It is only included to allow simpler migration of existing Apollo 4.0x 
				projects to Apollo 6.x. See the Apoll help file for details.

==========================================================================*)
                 
unit Apollo;

interface

Uses
   SysUtils, Windows, Classes, Forms, Dialogs, DB;

type
  TApollo = class( TComponent )
		private
      FDataSource: TDataSource;
      FIndexes: TStringList;
      FFilter: String;
      FTurboRead: Boolean;
		protected
			// .. Nothing ..
		public
			constructor Create(AOwner: TComponent); override;
      destructor  Destroy; override;
		published
      property DataSource: TDataSource read FDataSource write FDataSource;
      property ExtraIndexes: TStringList read FIndexes write FIndexes;
      property Filter: String read FFilter Write FFilter;
      property TurboRead: Boolean read FTurboRead write FTurboRead;
		end;

implementation

var
	FShown : Boolean;

{TApollo}
constructor TApollo.Create(AOwner: TComponent);
begin
	inherited Create(AOwner);
	FIndexes := TStringList.Create;

	// Only display this message once if multiple TApollo's were used
  if FShown = False then
  begin
  	MessageDlg( 'The TApollo component a stub that provides no functionality.' +#13+
  							'It is included to help migrate existing Apollo 4.x projects ' +#13+
                'to Apollo 6.1. See the help file for more details',
                mtInformation, [mbOk], 0 );
  	FShown := True;
  end;

end;

destructor TApollo.Destroy;
begin
	FIndexes.Free;
	inherited Destroy;
end;

end.


