(*============================================================================
  ApCommon.PAS
  Common Apollo code
  Applies to Apollo family of products

  Copyright 1999-2002 Vista Software
  Last Updated: 10-22-2002

  NOTE: Tab stops were set at 2 spaces during development of this unit. If you
        are using a tab stop setting other than 2 spaces, the code indents
        may not line up accurately in your editor.
============================================================================*)


unit ApCommon;


interface

Uses SDE60, Classes, SysUtils, Dialogs, DB;

Const

  VER_MONTH             = 10;          // Month of last update
  VER_DAY               = 2;          // Day of last update
  VER_YEAR              = 2002;        // Year of last update
  APDS_VER              = '6.1.0.0';    // Version number
  ApolloSQL_VER         = '6.1.0.0';    // Version number
  ApolloCONNECTION_VER  = '6.1.0.0';    // Version number  
  ApolloServerScript_VER= '6.1.0.0';
  ApolloADBInterface_VER= '6.1.0.0';
  ApolloADBX60_VER      = '6.1.0.0';
  ApolloServerDLL_VER   = '6.1.0.0';
  ApolloSDEInterface_VER= '6.1.0.0';

var

  IsApolloASPRunning :Boolean = FALSE;      // MED: 08-30-01, added
  ApolloDebugging    :Boolean = FALSE;       // MED: 09-07-01, added

Const
  DB_S_ENDOFCURSOR = 265923;
  E_DAO_FAIL           = 2147467259;
  S_DAO_OK             = 0;

Type

  {MED: 10-28-00, implement this for 7.0 in ApCommon}
  //TApolloErrorLevel = (ERRLEVEL_NONE, ERRLEVEL_FATAL, ERRLEVEL_STANDARD); {MED: 10-28-00, added}

  {MED: 12-25-99, added }

  TxProgressStatus = (psXStart, psXProgress, psXEnd);

  TxProgressEvent = procedure(Sender: tobject;  Status: TXProgressStatus;
    Min, Max, Position: Integer) of object;

  //SDENTX      = 1;  SDEFOX      = 2;  SDENSX      = 3;  SDENSX_DBT  = 4;
  // sx_USE function or better Call  ApolloTableType function
  // MED: 06-27-01, added SXNONE to make ApolloType same number as SDE*
  TApolloTableType  = (ttSXNONE, ttSXNTX, ttSXFOX, ttSXNSX, ttSXNSX_DBT); {MED: 03-05-2000, moved here from ApoDSet}

	//ac: 12-18-01, Added for constant name conflict with CB
	// TApolloCommit Level: 
	// 0=clFull, 1=clNormal, 2=clNone
	// Slowest     Normal    Fastest
	// C++Builder users must use 2 intead of  clNone
  TApolloCommitLevel = (clFull, clNormal, clNone);

  TAccessMethod     = (amLocal, amServer);  {MED: 03-05-2000, moved here from ApoDSet}
  TDriveType        = (dtUnknown, dtNoDrive, dtFloppy, dtFixed, dtNetwork, dtCDROM, dtRAM);
	TApolloDateFrmt   = (dfAmerican, dfAnsi, dfBritish, dfFrench, dfGerman,
   	                   dfItalian, dfSpanish, dfWinDefault);

             // 0        1         2            3          4              5      6
  TRowType = (rtNone, rtGoTop_BOF, rtGotop, rtGoBottom,   rtGoBottom_EOF, rtGo, rtSkip);



	//--------TADBInterface Support {MED: 04-21-01, Added}
  PADBRecList = ^ADBRecList;
  ADBRecList = record
    GetResult  : TGetResult;
    RecNum     : Integer;       // Physical Server Record Number
    OrderPosGet: Double;        // OrderPosGet (ordinal number)
    RecBuffer  : PChar;         // current data - same as SDEBuffer
    BOF        : Boolean;
    EoF        : Boolean;
    RowNo      : Integer;
    RowType    : TRowType;
    PreviousRow: Integer;
    NextRow    : Integer;
    Blobs      : array of pointer;
  end;


  TTickClock = class
  private
    iStartedClock : Integer;
    FProcessMessages : Boolean;
    Function MSSeconds : Integer;
  public
    procedure Sleep(iMS:Integer);
    function  Delay(iMS:Integer):Boolean;
    procedure Reset;
    constructor Create(bProcessMessage:Boolean);
  end;


function Padr ( cStr:String; nRepeat:Integer; cChar:Char): String;
function LogicalToYN(YN: Boolean): String;
function YNToLogical(YN: String): Boolean;
function SubStr(const cString:String; nStart,nEnd: Integer): String;
Function sLeft(const cString:string; nCount: Integer): string;

///////////////////////
function  InternalGoToRow(const RowNo:Integer):Integer;
function  InternalGoSkip(RowNo, OffSet:Integer):Integer;
function  InternalGetRowNo:Integer;
//////////////////////

procedure InternalGetRecord(var Stream:TMemoryStream);
function  InternalBreakRecords(pMem:TMemoryStream;
                               var BOF:Boolean;
                               var EoF:Boolean;
                               var RecNo:Integer;
                               var RowNo:Integer;
                               var OrderPosGet:Double;
                               var ActiveBuffer:PChar;
                               const RecSize : Integer):Boolean;


        {
Function InternalSDEFetchRecords(MemStream:TMemoryStream;
                      FetchCount, LastRecNo, iSkipRows:Integer;
                      iDirection:TSkipDirection;
                      FSetDeleted:Boolean):String;

         }


implementation

///////////////////////////////////////////////////////////////////////
// Padr()
/////////////////////////////////////////////////////////////////
function Padr ( cStr:String; nRepeat:Integer; cChar:Char): String;
begin
  Result := cStr + StringOfChar(cChar, nRepeat - Length(cStr) );
end;

function SubStr(const cString:String; nStart,nEnd: Integer): String;
begin
	Result := Copy(cString, nStart, nEnd);
end;

function LogicalToYN(YN: Boolean): String;
begin
  if YN then  	Result := 'Y'
  else        	Result := 'N';
end;

function YNToLogical(YN: String): Boolean;
begin
  Result := (YN = 'Y');
end;

Function sLeft(const cString:string; nCount: Integer): string;
Begin
	Result 		:= Copy(cString, 1, nCount) ;
End;


function  InternalGoToRow(const RowNo:Integer):Integer;
begin
  if (RowNo < 0) then             // BOF.  Occurs when Gofirst is clicked
  begin
    sx_GoTop;
    sx_Skip(-1);
    Result  := DB_S_ENDOFCURSOR;
    exit;
  end
  else if (RowNo >= sx_RecCount  ) then        // when RowNo = 100- EOF is requested
  begin
    sx_GoBottom;
    sx_Skip(1);
    Result := DB_S_ENDOFCURSOR;
    exit;
  end
  else
  begin
    // RowNo at this point is > -1 and < FRecCount which is to say
    // RowNo >=0 and <= FRecCount-1
    // when you add 1 to RowNo you get the record number
    // so when RowNo = FRecCount is EOF since (FRecCount + 1) is beyond our scope
    // same holds true when RowNo = -1 since (-1 + 1) is 0 and zero is not a valid record
   // if RowNo <> 0 then
    sx_Go(RowNo+1);
  end;
  Result := S_DAO_OK;

end;

function  InternalGetRowNo:Integer;
begin
  if      (sx_Bof  ) then		Result :=  -1
  else if (sx_Eof  ) then		Result := sx_RecCount
  else                      Result := sx_RecNo  -1 ;
end;

function  InternalGoSkip(RowNo, OffSet:Integer):Integer;
begin
  InternalGoToRow(RowNo);

  if (sx_BOF  ) AND (Offset > 0) then
  begin
    sx_GoTop;
    dec(Offset);
  end
  else if (sx_EOF  ) AND (Offset < 0) then
  begin
    sx_GoBottom;
    inc(Offset);
  end;
  if (Offset <> 0) then
    sx_Skip(OffSet);

  Result := InternalGetRowNo;
end;

///////////////////////////////////////////////////////////////////////////////////
procedure InternalGetRecord(var Stream:TMemoryStream);

  function  GetRowNo(bof, eof:Boolean; RecNo:Integer):Integer;
  begin
    if (Bof) Then		    Result :=  -1
    else if (Eof) then  Result := sx_RecCount
    else                Result := RecNo - 1;
  end;
var
  s           : String;
  BOF, EOF  : Boolean;
  cpRecord    : Pointer;
  RecNo, RowNo, iSize: Integer;
begin
  //showmessage('Inside InternalGetRecord-->'+inttostr(sx_RecSize)+'   '+sx_GetString('LAST'));
  Try
    iSize       := sx_RecSize+1;
    cpRecord    := AllocMem(iSize);  // 1 for deleted flag
    Try
      Eof       := sx_Eof;
      BOF       := sx_BOF;
      RecNo     := sx_RecNo;
      RowNo     := GetRowNo(bof, eof, RecNo);

      if sx_IndexOrd > 0 then
      begin
        s := LogicalToYN(BOF)+LogicalTOYN(EOF)+
          	 IntToHex(RecNo, 8)+
          	 IntToHex(RowNo, 8)+
          	 FloatToStrF( sx_OrderPosGet, ffGeneral, 10,0); // takes 12 bytes
      end
      else

      begin
        s := LogicalToYN(BOF)+LogicalTOYN(EOF)+
          	 IntToHex(RecNo, 8)+
          	 IntToHex(RowNo, 8)+
          	 FloatToStrF( RecNo, ffGeneral, 10,0); // takes 12 bytes

      end;

      sx_GetRecord(cpRecord);
      Stream.Write(pchar(s)^, 30);
      Stream.Write(cpRecord^, iSize);

      // add blobs here
    Finally
      FreeMem(cpRecord);
    End;
  Except
  End;
end;

function InternalBreakRecords(pMem:TMemoryStream;
                               var BOF:Boolean;
                               var EoF:Boolean;
                               var RecNo:Integer;
                               var RowNo:Integer;
                               var OrderPosGet:Double;
                               var ActiveBuffer:PChar;
                               const RecSize : Integer):Boolean;
var
  // Hint i,  ReadCount: Integer;
  Buff : Array [0..12] of char;
begin

  RowNo := -4;
//showmessage('InternalBreakRecord-->'+inttostr(pMem.Position)+'   Size->'+Inttostr(pMem.Size));
  if (pMem <> nil) and (pMem.Position < pMem.Size) then
  begin
    pMem.Read( pchar(@buff)^, 1);      buff[1] := #0;
    BOF := YNToLogical(buff);
    pMem.Read( pchar(@buff)^, 1);      buff[1] := #0;
    EOF := YNToLogical(buff);

    pMem.Read( pchar(@buff)^, 8);      buff[8] := #0; // Physical RecNo
    RecNo := StrToInt('$'+Buff);

    pMem.Read( pchar(@buff)^, 8);      buff[8] := #0;
    RowNo := StrToInt('$'+Buff);

    pMem.Read( pchar(@buff)^, 12);      buff[12] := #0; // OrderGetPos
    OrderPosGet := StrToFloat(buff);

    pMem.Read( PChar(ActiveBuffer)^, RecSize);   // Active Buffer itself
  end;
  // Hint  Result :=  (pMem.Position < pMem.Size);
  if RowNo = -4 then
    Result := FALSE
  else
    Result := TRUE;
//  if pMem.Position = pMem.Size then    showmessage('InternalBreakRecord-->'+inttostr(pMem.Position)+'   Size->'+Inttostr(pMem.Size));
end;



(*
Function InternalSDEFetchRecords(MemStream:TMemoryStream;
                      FetchCount, LastRecNo, iSkipRows:Integer;
                      iDirection:TSkipDirection;
                      FSetDeleted:Boolean):String;

var
  sError      : String;
  cpMemo : PChar;
  cRecord     : PChar;
  iStartRec, CurrRec,
  iRec1, iRec2,
  i,j, k, iLoop,
  iMove,
  FTableLength,
  FRecSize, FRecCount, FIndexOrd,
  FFieldCount,
  iCount, iBlobCount : Integer;
  FEOF, FBOF, NoMoreRecord  : Boolean;
  s,fName       : String;
  fType         : Char;
  cpRecord      : PChar;
  RecMem        : TMemoryStream;
  iPosition, iBlobPosition,
  iSize         : Integer;
  vp            : Pointer;
  sNN,sEof,sBof : String;
  bGetBlobsToo  : Boolean;

begin
  Result := '';
  MemStream.Clear;
  MemStream.Position := 0;
  s       := IntToHex(16, 8)+InttoHex(0,8);       // iSize+iCount
  MemStream.Write(pchar(s)^, 16);
///////////////
    try
      bGetBlobsToo := FALSE;
      FTableLength  := 0;
      FRecSize      := sx_RecSize;
      FFieldCount   := sx_FieldCount;
      for i:=1 to FFieldCount do
      begin
        fType := sx_FieldType(pchar(sx_FieldName(i)))[0];
        if (fType = 'M') or (fType = 'B') then
        begin
          bGetBlobsToo := TRUE;
          break;
        end;
      end;

      sEof := 'N'; sBof := 'N';
      iMove := 1;
      Case iDirection of
        sdRefresh:
          begin
            if LastRecNo <= sx_RecCount then sx_Go(LastRecNo);  // be sure not to overshoot last record
            sx_Skip(0); FetchCount := 1;
          end;
        sdRefreshAll:
          begin
           // sx_Go(LastRecNo);  sx_Skip(0);
          end;
        sdCurrent:  // whatever happens to be here //
          begin
          end;
        sdGoTop:
          begin
              sx_GoTop;     sBof := 'Y';   // force BOF
          end;
        sdGoBottom:
          begin
              sx_GoBottom;  sEof := 'Y';      iMove := -1;  // force EOF
          end;
        sdSkipping:
          begin
            if iSkipRows >= 0 then iMove := 1
            else                   iMove := -1;
            sx_Go(LastRecNo);
          end;
      End;
      sNN := sBof + sEof;

      FRecCount   := sx_RecCount;
      FIndexOrd   := sx_IndexOrd;
      if FetchCount < 1 then            FetchCount := 1;
      if FetchCount > FRecCount then    FetchCount := FRecCount;
      s := IntToHex(FRecCount, 8) + IntToHex(0, 8) + IntToHex(FIndexOrd, 4); // FRecCount + FRecLength + IndexOrd
      MemStream.Write(pchar(s)^, 20);

      iStartRec := sx_RecNo;       // this is not accurate when passed eof. it returns sx_RecCount + 1
      CurrRec   := iStartRec;
      //ServerError('sx_RecCount-->'+Inttostr(sx_RecCount)+'***iStartRec=>'+Inttostr(iStartRec)+' CurrRec->'+Inttostr(CurrRec), '');

      //ServerError('iStartRec=>'+Inttostr(iStartRec)+' CurrRec->'+Inttostr(CurrRec), '');
      if FRecCount < 2 then
        sNN := 'YY';

      cpRecord := AllocMem(FRecSize);
      Try

        iCount    := 0;
        //______________________________________________________________________
        Repeat
          //______________________________________________________________________
          //|PhysicalRec No  : 8 bytes
          //|OrdinalRec No   : 8 bytes
          //|BlobCount       : 4 Bytes  0 if none
          //|DATA            : FRecSize bytes
          //______________________________________________________________________
          if FIndexOrd > 0 then
          begin
            s  := sNN+ IntToHex(CurrRec, 8)+
                       IntToHex((trunc(sx_OrderPosGet * FRecCount)), 8)+
                       IntToHex(0,4);   // Blob Count
          end
          else
          begin
            s  := sNN+ IntToHex(CurrRec, 8)+ IntToHex(CurrRec, 8)+
                  IntToHex(0,4);   // Blob Count
          end;

          sx_GetRecord(cpRecord);
          MemStream.Write(pchar(s)^, 22);

          iBlobCount    := 0;
          iBlobPosition := MemStream.Position - 4;  // current BlobCount position
          MemStream.Write(cpRecord^, FRecSize);

          Inc(iCount);
          //____________________________________________
          // get blobs if any
          //|BlobField       : 20 Bytes  -- only if BlobCount > 0
          //|BlobLength      : 8 Bytes
          //|BlobData        : Variable bytes
          //____________________________________________
          if bGetBlobsToo then
          begin
            for i:=1 to FFieldCount do
            begin
              fType := sx_FieldType(pchar(sx_FieldName(i)))[0];
              if fType = 'M' then
              begin
                Try
                  {MED: 10-16-00 there is a memory leak in sx_GetMemo! }
                  fName := sx_FieldName(i);
                  cpMemo := sx_GetMemo(pchar(fName), 0);
                  iSize  := Length(String(cpMemo));
                  inc(iBlobCount);

                  s := Padr(fName, 20, ' ');
                  MemStream.Write(pchar(s)^, 20);

                  s := IntToHex(iSize, 8);
                  MemStream.Write(pchar(s)^, 8);

                  s := IntToHex(i, 4);      // field number
                  MemStream.Write(pchar(s)^, 4);

                  MemStream.Write(pchar(cpMemo)^, iSize);
                  sx_MemDealloc(cpMemo);
                Except
                  Result := ('ApolloServer.SDEFetchRecords. Cannot read memo '+fName);
                  exit;
                End;
              end
              else if fType = 'B' then
              begin
                fName := sx_FieldName(i);
                Result := ('DON''T SUPPORT BLOB RIGHT NOW. Cannot read memo '+fName);
                exit;
                vp := nil;

                try
                  iSize := sx_GetBlobLength(pchar(fName));
                  try
                    Inc(iSize);
                    GetMem(vp, iSize);
                  except
                    Result := ('ApolloServer.SDEFetchRecords.  Cannot read blob '+fName);
                    exit;
                  end;
                  MemStream.Clear;
                  if (sx_GetBlob(pchar(fName), vp)) <> (iSize -1)  then
                  begin
                    Result := ('ApolloServer.SDEFetchRecords. Cannot read blob '+fName);
                    exit;
                  end
                  else
                  begin
                    MemStream.SetSize(iSize-1);
                    MemStream.Position := 0;
                    MemStream.Write(vp^, iSize-1);  // write buffer to stream
                  end;
                finally
                  FreeMem(vp);
                end;
              end;
            end;
          end;
          iPosition := MemStream.Position;
          MemStream.Position := iBlobPosition;  // blobcount goes here!
          s := IntToHex(iBlobCount, 4);
          MemStream.Write(pchar(s)^, 4);
          MemStream.Position := iPosition;

          s := 'iCount >'+Inttostr(Trunc(iCount))+'  RecNo-->'+Inttostr(CurrRec);
          sx_Skip(iMove);

          //if sBof <> 'Y' then
          FBOF := sx_Bof;
          //if sEof <> 'Y' then
          FEOF := sx_Eof;
          //ServerError(s, '    FBOF->'+LogicalTOYN(FBOF)+'  FEOF->'+LogicalTOYN(FEOF) + '  '+sNN);
          // creates one of the two fanthom records
          if (FBOF) OR (FEOF) then
          begin
            sNN := '';
            if FBof then    sNN := 'Y'          else sNN := 'N';
            if FEof then    sNN :=  sNN + 'Y'   else sNN := sNN + 'N';
            iPosition := MemStream.Position;
            MemStream.Position := iBlobPosition-18;  // BOF / EOF
            MemStream.Write(pchar(sNN)^, 2);
            MemStream.Position := iPosition;
            // sx_RecCount returns deleted records. There could be one left deleted
            // this is a hack to get around it-- sx_Count is too slow-- this actually makes FRecCount more accurate-no deleted are reported
            if iCount = 1 then
            begin
              if FSetDeleted then
              begin
                if sx_Count < 1 then
                // this is a hack - sx_RecNO returns erronously
                begin
                  iCount := 0;
                  MemStream.Position := 16;          // FRecCount
                  s := InttoHex(0, 8);
                  MemStream.Write(pchar(s)^, 8);
                end;
              end;
            end;
            break;
          end;
          sNN  := 'NN';
          CurrRec := sx_RecNo;
        //________________________________________________________________________
        Until (iCount = FetchCount);
        //_______________________________________________________________________

        MemStream.Position := 8;
        s := InttoHex(iCount, 8);
        MemStream.Write(pchar(s)^, 8);

        sx_Go(iStartRec);
      Finally
        FreeMem(cpRecord);
      End;
    except
      sError := ('ApolloServer.SDEFetchRecords: SDEFetchRecords');
    end;
    MemStream.Position := 0;
end;
*)



Function TTickClock.MSSeconds : Integer;
begin
  Result := Trunc(Frac(now)*(24*3600*1000));
end;

function TTickClock.Delay(iMS:integer):Boolean;
//var
//  Msg: TMsg;        //<--Windows.pas
begin
  Result := FALSE;
  if (MSSeconds) >= (iStartedClock + iMS) then
    Result := TRUE;

  {
  // This guarantees it will not ever call Application.Idle
  if FProcessMessages then
  begin
    if PeekMessage(Msg, 0, 0, 0, PM_NOREMOVE) then
     Application.HandleMessage;

   // if FProcessMessages then
   //   Application.ProcessMessages;
  end;
  }
end;

procedure TTickClock.Reset;
begin
  iStartedClock := MSSeconds;
end;

procedure TTickClock.Sleep(iMS:Integer);
begin
  While (not Delay(iMS)) do
    ;
end;

constructor TTickClock.Create(bProcessMessage:Boolean);
begin
  inherited Create;
  iStartedClock := MSSeconds;
  FProcessMessages := bProcessMessage;
end;


end.




