(*============================================================================
  IntCrypt.PAS
  .DLL interface code for ApolloCrypt
  Copyright 1999-2002 Vista Software
  Last Updated: 10-22-2002
============================================================================*)

unit IntCrypt;

interface

uses
  Windows, Forms, Dialogs, classes, SysUtils, db;

const
	DLL_NAME = 'ApolloCrypt.DLL';  {MED:03-11-2001, changed}

var
  CryptDLLLoaded: Boolean = False; { is DLL (dynamically) loaded already? }

  CompressStream: procedure ( InStrm, OutStrm: TMemoryStream); stdcall;
  UnCompressStream: procedure (InStrm, OutStrm: TMemoryStream);stdcall;
  SetCompressionPassword: procedure (pPass:PChar); stdCall;
  SetCompressionLevel: procedure (iLevel:Integer); stdCall;

  procedure LoadCryptDLL;
  procedure UnLoadCryptDLL;

implementation

var
  CryptDLLHandle: THandle;
  ErrorMode: Integer;

procedure UnLoadCryptDLL;
begin
  if not CryptDLLLoaded then
    Exit;
    
  FreeLibrary(CryptDLLHandle);
end;

procedure LoadCryptDLL;
begin
  if CryptDLLLoaded then
    Exit;

  ErrorMode := SetErrorMode( $8000 );
  CryptDLLHandle := LoadLibrary( DLL_NAME );
  if CryptDLLHandle >= 32 then
  begin
    @CompressStream := GetProcAddress(CryptDLLHandle,'CompressStream');
    Assert(@CompressStream <> nil);

    @UnCompressStream := GetProcAddress(CryptDLLHandle,'UnCompressStream');
    Assert(@UnCompressStream <> nil);

    @SetCompressionPassword := GetProcAddress(CryptDLLHandle,'SetCompressionPassword');
    Assert(@SetCompressionPassword <> nil);

    @SetCompressionLevel := GetProcAddress(CryptDLLHandle,'SetCompressionLevel');
    Assert(@SetCompressionLevel <> nil);

    CryptDLLLoaded := True;
  end
  else
  begin
    CryptDLLLoaded := False; { Error: SDESQL*.DLL could not be loaded !! }
  end;
  SetErrorMode(ErrorMode);

  // If SDESQL*.DLL not loaded, report error & bail
  if (not CryptDLLLoaded) then
  begin
    begin

      MessageDlg('Missing required ' + DLL_NAME + '.' + #13#13 +
                 'Apollo Crypt is a add-on engine for Apollo.' + #13 +
                 'Visit www.vistasoftware.com to get your copy.',
                 mtError, [mbOk], 0);

       Application.Terminate;
    end;
	end;
end;

initialization

finalization
	if CryptDLLLoaded then
	  FreeLibrary(CryptDLLHandle);

end.
