(*============================================================================
  IntSQL.PAS
  IntSQL*.DLL interface code for ApolloSQL
  Copyright 1999-2002 Vista Software
  Last Updated: 12-15-2001
============================================================================*)

unit IntSQL;

interface

uses
  Windows, Forms, Dialogs, classes, SysUtils, db,
  ApCommon;


const
	DLL_NAME = 'ApolloSQL61.DLL';  {MED:03-11-2001, changed}

var
  SQLDLLLoaded: Boolean = False; { is DLL (dynamically) loaded already? }

  //============================
	dll_sql_Prepare: function(
                      Owner:TComponent;
                      var SQLID:Integer;
                      xqPregress: TxProgressEvent;
                      DefaultTableType:Integer;
                      DefaultPassword:PChar;
                      DefaultTranslate:Boolean;
                      iTableCount:Integer;
                      sTables, sPath:PChar;
                      FDeleted, FCentury:WordBool;
                      FMemoBlockSize:Integer;
                      FDateFormat : PChar;
                      FParamsStrm : TMemoryStream;
                      FReadOnly : Boolean; {CRVG : 2001-06-03, Added}
                      FCommitLevel : TApolloCommitLevel;
                      var iError : Integer ):PChar ; stdcall;


	dll_sql_OpenSQL: function(
                      SQLID:Integer;
                      FSQL : PChar;
                      var iRecCount : Integer;
                      var iFieldCount : Integer;
                      var iRecSize : Integer;
                      var iError : Integer):PChar;  stdcall;

	dll_sql_GetStructure: function(
                      SQLID:Integer;
                      var pMem : PChar;                         //var WriteStream : TMemoryStream;
                      var iSize : Integer):PChar;  stdcall;

	dll_sql_GetRecord: function(
                      SQLID:Integer;
                      var pMem: PChar ; //WriteStream : TMemoryStream;
                      iRecNo : Integer;
                      iFetchCount : Integer;
                      var iRecRead : Integer;
                      var iSize : Integer):PChar;  stdcall;


	dll_sql_ExecSQL: function(
                     SQLID:Integer;
                     FSQL : PChar;
                     FParamsStrm : TMemoryStream;
                     var iError : Integer):PChar;  stdcall;


	dll_sql_CloseSQL: function(SQLID:Integer; var iError:Integer):PChar; stdcall;

	dll_sql_UnPrepareSQL: function(SQLID:Integer; var iError:Integer ):PChar; stdcall;


	dll_sql_ReadBlobData: function(
                      SQLID:Integer;
                      var pMem : PChar; //WriteStream : TMemoryStream;
                      iRecNo : Integer;
                      iFieldIndex : Integer;
                      var iError : Integer):PChar;  stdcall;


	dll_sql_RecCount: function(
                      SQLID:Integer;
                      var iRecCount: Integer;
                      var iError : Integer):PChar;  stdcall;

	dll_sql_Refresh: function(
                      SQLID:Integer;
                      var iError : Integer):PChar;  stdcall;


  /////////////////////
  // MED:09-07-01, added
  /////////////////////
  dll_sql_SetSystemCollation: procedure ;  stdcall;
  dll_sql_SetMachineCollation: procedure ;  stdcall;
  dll_sql_AddDudenCollation: procedure ; stdcall;
  dll_sql_AddEtecCollation: procedure ; stdcall;

  procedure LoadSQLDLL;

implementation

var
  SQLDLLHandle: THandle;
  ErrorMode: Integer;

procedure LoadSQLDLL;
begin
  if SQLDLLLoaded then
    Exit;

  ErrorMode := SetErrorMode( $8000 );
  SQLDLLHandle := LoadLibrary( DLL_NAME );

  //GetModuleFileName(SQLDLLHandle, pDllFullPath, 255);   // MED: 08-20-01, added

  if SQLDLLHandle >= 32 then
  begin

    @dll_sql_Prepare := GetProcAddress(SQLDLLHandle,'dll_sql_Prepare');
    Assert(@dll_sql_Prepare <> nil);

    @dll_sql_OpenSQL := GetProcAddress(SQLDLLHandle,'dll_sql_OpenSQL');
    Assert(@dll_sql_OpenSQL <> nil);

    @dll_sql_GetStructure := GetProcAddress(SQLDLLHandle,'dll_sql_GetStructure');
    Assert(@dll_sql_GetStructure <> nil);

    @dll_sql_GetRecord := GetProcAddress(SQLDLLHandle,'dll_sql_GetRecord');
    Assert(@dll_sql_GetRecord <> nil);

    @dll_sql_ExecSQL := GetProcAddress(SQLDLLHandle,'dll_sql_ExecSQL');
    Assert(@dll_sql_ExecSQL <> nil);

    @dll_sql_CloseSQL := GetProcAddress(SQLDLLHandle,'dll_sql_CloseSQL');
    Assert(@dll_sql_CloseSQL <> nil);

    @dll_sql_UnPrepareSQL := GetProcAddress(SQLDLLHandle,'dll_sql_UnPrepareSQL');
    Assert(@dll_sql_UnPrepareSQL <> nil);

    @dll_sql_ReadBlobData := GetProcAddress(SQLDLLHandle,'dll_sql_ReadBlobData');
    Assert(@dll_sql_ReadBlobData <> nil);

    @dll_sql_RecCount := GetProcAddress(SQLDLLHandle,'dll_sql_RecCount');
    Assert(@dll_sql_RecCount <> nil);

    @dll_sql_Refresh := GetProcAddress(SQLDLLHandle,'dll_sql_Refresh');
    Assert(@dll_sql_Refresh <> nil);

    /////////
    // MED: Added 09-10-01, added
    @dll_sql_SetSystemCollation := GetProcAddress(SQLDLLHandle,'dll_sql_SetSystemCollation');
    Assert(@dll_sql_SetSystemCollation <> nil);

    @dll_sql_SetMachineCollation := GetProcAddress(SQLDLLHandle,'dll_sql_SetMachineCollation');
    Assert(@dll_sql_SetMachineCollation <> nil);

    @  dll_sql_AddDudenCollation := GetProcAddress(SQLDLLHandle,'dll_sql_AddDudenCollation');
    Assert(@dll_sql_AddDudenCollation <> nil);

    @dll_sql_AddEtecCollation := GetProcAddress(SQLDLLHandle,'dll_sql_AddEtecCollation');
    Assert(@dll_sql_AddEtecCollation <> nil);

    SQLDLLLoaded := True;
  end
  else
  begin
    SQLDLLLoaded := False; { Error: SDESQL*.DLL could not be loaded !! }
  end;
  SetErrorMode(ErrorMode);
                   
  // If SDESQL*.DLL not loaded, report error & bail
  // ASP checks SQLDLLoaded and Response.Write
  if (not SQLDLLLoaded) AND (not IsApolloASPRunning) then
  begin
    begin
      MessageDlg('Missing required ' + DLL_NAME + '.' + #13#13 +
                 'Apollo SQL is a SQL add-on engine for Apollo.' + #13 +
                 'Visit www.vistasoftware.com to get your copy.',
                 mtError, [mbOk], 0);

       Application.Terminate;
    end;
	end;
end;

initialization

finalization
	if SQLDLLLoaded then
	  FreeLibrary(SQLDLLHandle);

end.
