unit ILConfig_Apollo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ILConfig, Spin, APwin, ApConn, StdCtrls, ApoEnv, Db, ApoQSet, ComCtrls,
  ExtCtrls;

type
  TformILConfigApollo = class(TILConfig)
    pctrlApollo: TPageControl;
    Panel1: TPanel;
    butnOk: TButton;
    butnCancel: TButton;
    tabsConnection: TTabSheet;
    tabsAuthentication: TTabSheet;
    Label1: TLabel;
    cboxServer: TComboBox;
    Label2: TLabel;
    editServer: TEdit;
    Label3: TLabel;
    sedtPort: TSpinEdit;
    Label4: TLabel;
    editDatabase: TEdit;
    Label5: TLabel;
    editUsername: TEdit;
    Label6: TLabel;
    editPassword: TEdit;
    procedure cboxServerChange(Sender: TObject);
  private
  public
    class function Edit(var VDatasource, VOptions, VUsername, VPassword: string): boolean; override;
  end;

var
  formILConfigApollo: TformILConfigApollo;

implementation
{$R *.DFM}

{ TformILConfigApollo }

class function TformILConfigApollo.Edit(var VDatasource, VOptions,
  VUsername, VPassword: string): boolean;
var
  LPort: Integer;
  LAccess,
  LServer: string;
  LIndex: Integer;
begin
  with TformILConfigApollo.Create(nil) do try
    pctrlApollo.ActivePageIndex := 0;
    LIndex := AnsiPos('|', VOptions);
    if LIndex = 0 then begin
      LAccess := 'amLocal';
      LServer := '';
      LPort := -1;
    end else begin
      LAccess := Copy(VOptions, 1, LIndex - 1);
      Delete(VOptions, 1, LIndex);
      LIndex := AnsiPos('|', VOptions);
      LServer := Copy(VOptions, 1, LIndex - 1);
      Delete(VOptions, 1, LIndex);
      LPort := StrToIntDef(VOptions, -1);
    end;
    if AnsiSameText(LAccess, 'amServer') then begin
      cboxServer.ItemIndex := 1;
    end else begin
      cboxServer.ItemIndex := 0;
    end;
    cboxServer.OnChange(nil);
    if LPort > 0 then begin
      sedtPort.Value := LPort;
    end else begin
      sedtPort.Value := 8121;
    end;
    editServer.Text := LServer;
    editDatabase.Text := VDataSource;
    editUsername.Text := VUsername;
    editPassword.Text := VPassword;

    Result := ShowModal = mrOk;
    if Result then begin
      VUsername := editUsername.Text;
      VPassword := editPassword.Text;
      if cboxServer.ItemIndex = 0 then begin
        VOptions := 'amLocal';
      end else begin
        VOptions := 'amServer|' + editServer.Text + '|' + sedtPort.Text;
      end;
      VDataSource := editDatabase.Text;
    end;
  finally
    Free;
  end;
end;

procedure TformILConfigApollo.cboxServerChange(Sender: TObject);
begin
  if cboxServer.ItemIndex = 0 then begin
    editServer.Enabled := False;
    sedtPort.Enabled := False;
    editServer.Color := clBtnFace;
    sedtPort.Color := clBtnFace;
  end else begin
    editServer.Enabled := True;
    sedtPort.Enabled := True;
    editServer.Color := clWindow;
    sedtPort.Color := clWindow;
  end;
end;

end.
