(*============================================================================
  ApClass.PAS

  Copyright 1999-2001 Vista Software
  Last Updated: 10-22-2002

  NOTE: Tab stops were set at 2 spaces during development of this unit. If you
        are using a tab stop setting other than 2 spaces, the code indents
        may not line up accurately in your editor.

  MED: 02-27-00, created to support DLL handling and parameter passing by client
============================================================================*)

unit apCLass;


interface

Uses
  Windows, SDE60, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ExtCtrls;
Type
  TErrorMsg     = ShortString;
  TExecType     = (etGetParams, etSetParams, etExecProc);
  TAccessMethod = (amLocal, amServer);
  TDLLMessage   = procedure (msg:PChar) of object;

  TSessionData = Class(TPersistent)
  private
    FParams      : TParams;     {MED: 12-25-99, added for thread-safe support}
    FTag         : Integer;
    FWA          : Integer;   // Current workarea for client
    FWASelected  : Array[0..255] of Integer;
    FTableName   : Array[0..255] of String;    // ApolloTable
    FDataBaseName: Array[0..255] of String;    // path for each ApolloTable
    FDataPath    : Array[0..255] of String;    // path for TApolloTable
    FTableAlias  : Array[0..255] of String;
    FTableDriverType : Array[0..255] of SmallInt;

    FDLLPath      : ShortString;

    FErrorMsg     : TErrorMsg;    // MED: 04-02-2001
    FErrorNo      : Integer;
    FOnDLLMessage : TDLLMessage;  //MED: 03-05-2002 added

    function  GetWASelected(Index: Integer): Integer;
    procedure SetWASelected(Index: Integer; Value: Integer);
    function  GetTableName(Index: Integer): String;
    procedure SetTableName(Index: Integer; Value: String);
    function  GetDataBaseName(Index: Integer): String;
    procedure SetDatabaseName(Index: Integer; Value: String);
    function  GetPath(Index: Integer): String;
    procedure SetPath(Index: Integer; Value: String);
    function  GetTableAlias(Index: Integer): String;
    procedure SetTableAlias(Index: Integer; Value: String);
    function  GetTableDriverType(Index: Integer): SmallInt;
    procedure SetTableDriverType(Index: Integer; Value: SmallInt);
  public
    constructor Create(Owner:TObject);
    destructor Destroy; override;

    //======================================
    // MED: 04-02-2001-  255 length
    property ErrorMsg     : TErrorMsg read FErrorMsg write FErrorMsg;
    // MED: 04-02-2001-  255 length
    //between  -65535..65535  (4 bytes) -1 is internal anything else is user-defined
    property ErrorNo      : Integer read FErrorNo write FErrorNo;
    //======================================

    property DLLPath : ShortString read FDLLPath write FDLLPath;      // MED : 04-20-01, added
    property Params : TParams read FParams write FParams;
    property DataBaseName[index: Integer]: String  read GetDataBaseName write SetDataBaseName;
    property DataPath[index: Integer]: String  read GetPath write SetPath;
    property TableName[Index: Integer]: String  read GetTableName write SetTableName;
    property TableAlias[Index: Integer]: String  read GetTableAlias write SetTableAlias;
    property TableDriverType[Index: Integer]: SmallInt read GetTableDriverType write SetTableDriverType;
    property Tag : Integer read FTag write FTag;
    property WA: Integer read FWA write FWA;
    property WASelected[Index:Integer]:Integer read GetWASelected write SetWASelected;

    {MED: 03-05-2002 added to paint on server's canvas}
    property DLLMessage: TDLLMessage read FOnDLLMessage write FOnDLLMessage;

    procedure Test ;

 end;

implementation


{TSessionData}
constructor TSessionData.Create(Owner:TObject);
begin
  FParams     := TParams.Create;
  FTag        := 0;
end;

destructor TSessionData.Destroy;
begin
  FreeAndNil(FParams);
end;

procedure TSessionData.Test;
begin
  Showmessage('Success');
end;


function  TSessionData.GetWASelected(Index: Integer): Integer;
begin
  Result := FWASelected[Index];
end;

procedure TSessionData.SetWASelected(Index: Integer; Value: Integer);
begin
  FWASelected[Index] := Value;
end;

function  TSessionData.GetTableName(Index: Integer): String;
begin
  Result := FTableName[Index];
end;

procedure TSessionData.SetTableName(Index: Integer; Value: String);
begin
  FTableName[Index] := Value;
end;

function  TSessionData.GetDataBaseName(Index: Integer): String;
begin
  Result := FDataBaseName[Index];
end;

procedure TSessionData.SetDataBaseName(Index: Integer; Value: String);
begin
  FDataBaseName[Index] := Value;
end;

function  TSessionData.GetPath(Index: Integer): String;
begin
  Result := FDataPath[Index];
end;

procedure TSessionData.SetPath(Index: Integer; Value: String);
begin
  FDataPath[Index] := Value;
end;

function  TSessionData.GetTableAlias(Index: Integer): String;
begin
  Result := FTableAlias[Index];
end;

procedure TSessionData.SetTableAlias(Index: Integer; Value: String);
begin
  FTableAlias[Index] := Value;
end;

function  TSessionData.GetTableDriverType(Index: Integer): SmallInt;
begin
  Result := FTableDriverType[Index];
end;

procedure TSessionData.SetTableDriverType(Index: Integer; Value: SmallInt);
begin
  FTableDriverType[Index] := Value;
end;


end.
