(*============================================================================
  ApConst.PAS
  Apollo Client/Server Constants

  Copyright 1999-2001 Vista Software
  Last Updated: 10-22-2002

  NOTE: Tab stops were set at 2 spaces during development of this unit. If you
        are using a tab stop setting other than 2 spaces, the code indents
        may not line up accurately in your editor.
============================================================================*)

Const
	SECONDS_PER_DAY = (60*60*24);

	sc_NOTHING         = '0000';       {MED: 01-16-01, Added to support generic calls}


  // Triggers sent from Server to clients
	sc_TRIG_PROGRESS   = '0300';       {MED: 12-30-99, Added to support OnServerProgress}
  sc_TRIG_MESSAGE    = '0301';
  sc_TRIG_SHUTDOWN   = '0302';
  sc_TRIG_STREAM     = '0303';       {MED: 01-27-01, Added to support OnServerStream for triggers only}


  //SDE
	sc_WHOAREYOU       = '0448';       {MED: 12-30-99, prefixed rest with sc*}
	sc_WRONG_SERVERID  = '0449';
	sc_MAXEDCONNECTION = '0450';
	sc_ACCESS_ACCT     = '0451';
	sc_ACCESS_DENIED   = '0453';
	sc_ROUTER_DOWN     = '0454';
	sc_SERVER_DOWN     = '0455';
	sc_ACCESS_ERROR    = '0456';
	sc_ACCESS_OK       = '0457';
	sc_ALLDONE         = '0458';
	sc_CONNECTIONID    = '0459';
	sc_FILERECEIVE     = '0036';
	sc_FILESEND        = '0037';
	sc_FILELENGTH      = '0038';
	sc_GETDATABASENAMES= '0039';
	sc_GETTABLENAMES   = '0040';
	sc_DATACOMPRESSION = '0041';
	sc_ExecProc        = '0042';
  sc_GetProcedureNames  = '0043';
	sc_GetParams       = '0044';
	sc_SetParams       = '0045';
	sc_GETINDEXNAMES   = '0046';  // gets a list of indicies not same as INDEXNAME
	sc_GAUGE           = '0047';
	sc_TEST            = '0048';
	sc_REJECTEDMAXCON  = '0049';
	sc_REJECTEDPASS    = '0050';
	sc_REJECTEDUSER    = '0051';
	sc_DATASECURED     = '0052';
	sc_SERVERNAME      = '0053';
	sc_FILEEXISTS      = '0054';
	sc_DELETEFILE      = '0055';
  sc_GETSERVERDATETIME= '0056';
  sc_GETDLLPROCS     = '0057';    {LAS: 01-16-2000, Added. Gets .DLL proc names}
  sc_GETFILES        = '0058';    {MED: 01-16-2000, added.  Gets a list of files}
  sc_FINDDRIVES      = '0059';    {MED: 01-23-2000, added.  Gets a list of drives}
  sc_FINDDIRECTORIES = '0060';    {MED: 01-23-2000, added.  Gets a list of directories}
  sc_FINDFILES       = '0061';    {MED: 01-23-2000, added.  Gets a list of files}
  sc_GETUSERNAMES    = '0062';    {MED: 03-05-2000, added}

  {MED: 09-08-00, added function capability}
  sc_CreateScript     = '0063';
  sc_StopScript       = '0064';
  sc_GetScriptsList   = '0065';
  sc_DropScript       = '0066';
  sc_RunScript        = '0067';
  sc_CheckScriptSyntax= '0068';
  sc_UpdateScriptText = '0069';
  sc_GetScriptText    = '0070';

  sc_FileIsInUse      = '0071';   {09-30-00, Added}
  sc_COPYFILE_EX      = '0072';   {MED:03-23-01, copies files ON the server}
                                  {not to be confused by COPYFILE which is ADB API call}

  sc_GETSERVERLOG    = '0073';

  sc_Login           = '0464';
  sc_Logout          = '0465';

	sc_UseEX           = '0467';    //MED: 01-29-02, added
	sc_USE             = '0468';
	sc_QUICKUSE        = '0469';
	sc_RECCOUNT        = '0470';
	sc_QUERY           = '0471';
	sc_APPEND          = '0472';
	sc_APPENDBLANK     = '0473';
	sc_APPENDFROM      = '0474';
	sc_BLOBTOFILE      = '0475';
	sc_BOF             = '0476';
	sc_DELETE          = '0477';
	sc_DELETED         = '0478';
	sc_EOF             = '0479';
	sc_GETBLOB         = '0480';
	sc_GETBLOBLENGTH   = '0481';
	sc_GETBYTE         = '0482';
  sc_GETDATEJULIAN   = '0483';
  sc_GETDATESTRING   = '0484';
  sc_GETDOUBLE       = '0485';
  sc_GETINTEGER      = '0486';
  sc_GETLOGICAL      = '0487';
  sc_GETLONG         = '0488';
  sc_GETMEMO         = '0489';
  sc_GETRECORD       = '0490';
  sc_GetSTRING       = '0491';
	sc_GETTRIMSTRING   = '0492';
  sc_GO              = '0493';
  sc_GOBOTTOM        = '0494';
	sc_GOTOP           = '0495';
	sc_KEYADD          = '0496';
	sc_KEYDROP         = '0497';
	sc_PUTBLOB         = '0498';
  sc_RECNO           = '0500';
	sc_REPLACE         = '0501';
	sc_RLOCK           = '0502';
	sc_SEEK            = '0503';
	sc_SELECT          = '0504';
	sc_SETSOFTSEEK     = '0505';
	sc_SETEXACT        = '0506';
	sc_SETORDER        = '0507';
	sc_SETDELETED      = '0508';
	sc_SKIP            = '0509';
	sc_UNLOCK          = '0510';
	sc_COMMIT          = '0511';
  sc_COMMITLEVEL     = '0512';      //MED: 09-12-2002, added
	sc_DESCEND         = '0513';
	sc_RECSIZE         = '0514';
	sc_READRECORD      = '0515';
	sc_COUNT           = '0516';
	sc_TagArea         = '0517';
	sc_TagName         = '0518';
	sc_QUERYRECCOUNT   = '0519';
	sc_ORDERRECNO      = '0520';
	sc_PACK            = '0521';
	sc_ZAP             = '0522';
	sc_WRITERECORD     = '0499';
	sc_CLOSETABLE      = '0523';
	sc_ORDERPOSGET     = '0524';
	sc_INDEXNAME       = '0525';
	sc_INDEXORD        = '0526';
	sc_INDEXCOUNT      = '0527';
	sc_INDEXDESCEND    = '0528';
	sc_LOCATE          = '0529';
	sc_ALIAS           = '0530';
	sc_BASEDATE        = '0531';
	sc_BASENAME        = '0532';
	sc_CLOSEINDEXES    = '0533';
	sc_INDEX           = '0534';
	sc_COPYFILE        = '0535';
	sc_COPYFILETEXT    = '0536';
	sc_DBFDECRYPT      = '0537';
	sc_DBFENCRYPT      = '0538';
	sc_DBFILTER        = '0539';
	sc_EMPTY           = '0540';
	sc_ERRORLEVEL      = '0541';
	sc_REINDEX         = '0542';
	sc_EVALLOGICAL     = '0543';
	sc_EVALNUMERIC     = '0544';
	sc_EVALSTRING      = '0545';
	sc_EVALTEST        = '0546';
	sc_FLOCK           = '0547';
	sc_FOUND           = '0548';
	sc_GETQUERYBIT     = '0549';
	sc_GETSCOPE        = '0550';
	sc_INDEXCLOSE      = '0551';
	sc_INDEXCONDITION  = '0552';
	sc_INDEXTYPE       = '0553';
	sc_INDEXKEY        = '0554';
	sc_INDEXKEYFIELD   = '0555';
	sc_SETCENTURY      = '0556';
	sc_SETDATEFORMAT   = '0557';
	sc_ORDERPOSSET     = '0558';
	sc_CREATEEXEC      = '0559';
	sc_CREATEFIELD     = '0560';
	sc_CREATEFROM      = '0561';
	sc_CREATENEW       = '0562';
	sc_SYSPROP         = '0563';
	sc_INDEXTAG        = '0564';
	sc_CLOSEALL        = '0565';
	sc_SETPASSWORD     = '0566';
	sc_SETSCOPE        = '0567';
	sc_INDEXFLIP       = '0568';
	sc_RECALL          = '0569';
	sc_QUERYTEST       = '0570';
	sc_WORKAREA        = '0571';
	sc_DECRYPT         = '0572';
	sc_ENCRYPT         = '0573';
	sc_FILTERALIAS     = '0574';
	sc_FILTERDLG       = '0575';
	sc_SETTURBOREAD    = '0576';
	sc_SetLockTimeOut  = '0577';
	sc_IsEncrypted     = '0578';
	sc_KEYDATA         = '0579';
	sc_LOCKED          = '0580';
	sc_GETSTRUCTURE    = '0581';
	sc_READFIELDS      = '0582';
	sc_SETFIELDS       = '0583';
	sc_PUTMEMO         = '0584';
  sc_SETQUERYBIT     = '0585';
  sc_SEEKBIN         = '0586';
  sc_SETTRANSLATE    = '0587';
  sc_DBRLockList     = '0588';
  sc_LockCount       = '0589';
  sc_SETRELATION     = '0590';
  sc_TRAVERSETABLE   = '0591';
  sc_SETFILTER       = '0592';   {LAS: 11-19-99, Added}
  sc_SETEPOCH        = '0593';   {LAS: 11-19-99, Added}
  sc_SETMEMOBLOCKSIZE= '0594';   {LAS: 11-19-99, Added}
  sc_RYOFILTERACTIVATE='0595';   {LAS: 11-19-99, Added}
  sc_RYOFILTERCOPY   = '0596';   {LAS: 11-19-99, Added}
  sc_RYOFILTERCREATE = '0597';   {LAS: 11-19-99, Added}
  sc_RYOFILTERDESTROY= '0598';   {LAS: 11-19-99, Added}
  sc_RYOFILTERGETBIT = '0599';   {LAS: 11-19-99, Added}
	sc_RYOFILTERRESTORE= '0600';   {LAS: 11-19-99, Added}
	sc_RYOFILTERSAVE   = '0601';   {LAS: 11-19-99, Added}
	sc_RYOFILTERSETBIT = '0602';   {LAS: 11-19-99, Added}
	sc_RYOKEYADD       = '0603';   {LAS: 11-19-99, Added}
  sc_RYOKEYDROP      = '0604';   {LAS: 11-19-99, Added}
	sc_FIELDCOUNT      = '0610';
	sc_FIELDDECIMALS   = '0611';
	sc_FIELDNAME       = '0612';
	sc_FIELDNUM        = '0613';
	sc_FIELDOFFSET     = '0614';
	sc_FIELDTYPE       = '0615';
	sc_FIELDWIDTH      = '0616';
	sc_GetPage         = '0617';
  sc_VERSION         = '0618';
  sc_INDEXOPEN       = '0620';   {LAS: 11-28-99, Added}
  sc_ENVSETTINGS     = '0621';
  sc_COPYSTRUCTURE   = '0622';
  sc_CopyStructureExtended = '0623';  {MED: 03-07-2000, added}
  sc_PUTBLOBBYTES    = '0624';        {MED: 03-07-2000, added returns # bytes written}
  sc_OPENMODE        = '0625';        {MED: 03-16-00, added}
  sc_MULTITRAVERSETABLE  = '0626';
//  sc_SDEFetchRecords  = '0627';
	sc_SendWriteStream  = '0628';       {MED: 01-16-01, Added to support generic calls}


  sc_SetCompressionPassword  = '0629';      //MED: 04-04-01, added
	sc_QUERYSETEXACT           = '0630';
	sc_TagDelete               = '0631';

	sc_GoBofRecord             = '0632';
	sc_GoEofRecord             = '0633';
	sc_GoBottomRecord          = '0634';
	sc_GoTopRecord             = '0635';
  sc_GoSkip                  = '0636';
  sc_GoRecord                = '0637';
  sc_GETTABLETYPE            = '0638';      // MED: 07-31-01 , added
  sc_GoGetRecord             = '0639';      // MED: 08-14-01 , added


  sc_SetSystemCollation    = '0640';        // MED: 09-09-01, added
  sc_SetMachineCollation   = '0641';
  sc_AddDudenCollation     = '0642';
  sc_AddEtecCollation      = '0643';
  sc_GoToRow               = '0644';        // MED: 01-29-2002, added
  sc_GetRowNo              = '0645';
  sc_QueryRowCount         = '0646';
  sc_CreateConnection      = '0647';

  sc_IsServerConnectedToRelay = '0648';
  sc_GetServerListFromRelay = '0649';

  /////////////////////////////////////////////////
  sc_tps_BEGINTRANSACTION = '0700';
  sc_tps_COMMIT           = '0701';
  sc_tps_ROLLBACK         = '0702';
  sc_tps_APPLYUPDATES     = '0703';

  sc_sql_PREPARE          = '0800';
  sc_sql_UNPREPARE        = '0801';
  sc_sql_OPENSQL          = '0802';
  sc_sql_EXECSQL          = '0803';
  sc_sql_CLOSESQL         = '0804';
  sc_sql_RECCOUNT         = '0805';
  sc_sql_GETSTRUCTURE     = '0806';
  sc_sql_READRECORD       = '0807';
  sc_sql_READBLOBDATA     = '0808';
  sc_sql_REFRESH          = '0809';
  sc_sql_CREATETABLE      = '0810';
  sc_sql_CREATEINDEX      = '0811';

  sc_SQL_SetSystemCollation    = '0820';
  sc_SQL_SetMachineCollation   = '0821';
  sc_SQL_AddDudenCollation     = '0822';
  sc_SQL_AddEtecCollation      = '0823';



