(*============================================================================
  CompStream.PAS
  Main TApolloConnection code
  
  Copyright 1999-2002 Vista Software
  Last Updated: 10-22-2002
  
  NOTE: Tab stops were set at 2 spaces during development of this unit. If you
        are using a tab stop setting other than 2 spaces, the code indents
        may not line up accurately in your editor.
============================================================================*)

unit compStream;


interface

uses Classes, Dialogs, Controls, SysUtils, ActiveX,
  DB   // For TParam

 {$ifdef VER150}  {MED: 09-20-02, Added for D7 support}
  , Variants
 {$endif}
  {$ifdef VER140}  // [ac] 8-21-01 Delphi 6 support
  , Variants
  {$endif}

  ;

function ComponentToVar(Component: TComponent): String;
function VarToComponent(Value: String): TComponent;

function ComponentToVariant(Component: TComponent):Variant;
function VariantToComponent(Value: Variant): TComponent;

procedure StreamToVariant(M: TMemoryStream; var V: Variant);
procedure VariantToStream(V: array of Variant; var M: TMemoryStream);

procedure VarArrayToPointer(Value: OleVariant;  var Ptr: Pointer);
procedure PointerToVarArray(ptr: Pointer; iSize:Integer; var Value: OleVariant);
//Function  LogicalToYN(YN: Boolean): string;

procedure ParamsToStream(Params:TParams; var M: TMemoryStream);
procedure StreamToParams( M:TMemoryStream; var Params:TParams);

implementation

{Function LogicalToYN(YN: Boolean): string;
begin
  if YN then Result   := 'Y'
  else       Result   := 'N';
end;  }

function Padr ( cStr:String; nRepeat:Integer; cChar:Char): String;
begin
  Result := cStr + StringOfChar(cChar, nRepeat - Length(cStr) );
end;

function SubStr(const cString:String; nStart,nEnd: Integer): String;
begin
	Result := Copy(cString, nStart, nEnd);
end;

////////////////////////////////
// MED: 09-05-01, written
// due to a bug in D6 we can't use M directly.  We must Save it to ME and use ME
// instead
////////////////////////////////
procedure ParamsToStream(Params:TParams; var M: TMemoryStream);
var
  i,  size : Integer;         // Hint  j,
  sName, sType, cSize : String;
  buffPtr     : Pointer;
begin
  buffPtr    := nil;
  M.Clear;
  M.Position := 0;
  //===============================================
  if Params <> nil then
  with Params do
  begin
    for i:= 0 to Params.Count -1 do
    begin
      size := Items[i].GetDataSize;
      try
        buffPtr := AllocMem(size);
        Items[i].GetData( BuffPtr);

        cSize := IntToHex(Size, 8);
        M.Write(PChar(cSize)^, 8);

        sType := IntToHex(ord(Items[i].DataType), 2);
        M.Write(PChar(sType)^, 2);

        sType := IntToHex(ord(Items[i].ParamType), 2);
        M.Write(PChar(sType)^, 2);

        sName := PadR(Items[i].name, 20, ' ');
        M.Write(PChar(sName)^, 20);
        M.Write(PChar(Buffptr)^, size);
      finally
        FreeMem(BuffPtr);
      end;
    end;
  end;
  M.Position := 0;
end;

////////////////////////////////
// MED: 09-05-01, written
// due to a bug in D6 we can't use M directly.  We must Save it to ME and use ME
// instead
////////////////////////////////
procedure StreamToParams( M:TMemoryStream; var Params:TParams);
var
  // Hint i, , j: Integer;
  nRead, ToRead : Integer;
  sName   : String;
  buffPtr : Pointer;
  ftType  : TFieldType;
  ptType  : TParamType;
  me      : TMemoryStream;
begin
  me := TMemoryStream.Create;
  M.SaveToStream(me);
  if ME.Size = 0 then
  begin
    me.Free;
    exit;
  end;

  buffPtr       := nil;
  try
    ME.Position := 0;
    nRead := 0;

    GetMem(BuffPtr, ME.Size);
    Repeat
      ToRead := 0;
      nRead := nRead + ME.Read( PChar(buffPtr)^, 8);
      if nRead > 0 then
      begin
        try
          ToRead := StrToInt('$'+SubStr(PChar(buffPtr),1 ,8));
        except
        end;
      end;
      if ToRead > 0 then
      begin
        nRead := nRead + ME.Read( PChar(buffPtr)^, 2);   // datatype
        ftType := TFieldType(StrToInt('$'+SubStr(PChar(buffPtr),1,2)));
        //showmessage('dType->'+IntToStr(ord(ftType)));
        nRead := nRead + ME.Read( PChar(buffPtr)^, 2);   // paramtype
        ptType := TParamType(StrToInt('$'+SubStr(PChar(buffPtr),1,2)));
        nRead := nRead + ME.Read( PChar(buffPtr)^,20 ); // name
        sName := Trim(SubStr(PChar(buffPtr), 1, 20));
        nRead := nRead + ME.Read( PChar(buffPtr)^, ToRead ); // Data
        //showmessage('buff->'+PChar(buffPtr)+'<==   sName==>'+sName+'<===');
        if Params.FindParam(sName) = nil then
        begin
          Params.CreateParam(ftType, sName, ptType);
        end;
        if Params.FindParam(sName) <> nil then
        begin
          if Params.ParamByName(sName).ParamType = ptInput then   // ptInput not defined anywher!!!
            Params.ParamByName(sName).SetData(BuffPtr);
        end;
      end;
    Until ( (nRead = ME.Size)); // and (ToRead = 0) );
  finally
    FreeMem(BuffPtr);
    M.Position := 0;
    Me.Free;
  end;
end;

////////////////////////////////////////////////////////////
// MED: 03-07-01
// Binary conversion between an Automation client and server
///////////////////////////////////////////////////////////
procedure PointerToVarArray(ptr: Pointer; iSize:Integer; var Value: OleVariant);
var
  Data: Pointer;
begin
  Value := VarArrayCreate([0, iSize-1], varByte);
  Data  := VarArrayLock(Value);
  try
    Move(ptr^, Data^, iSize);
  finally
    VarArrayUnlock(Value);
  end;
end;

// don't forget to FreeMem in the calling routine
procedure VarArrayToPointer(Value: OleVariant;  var Ptr: Pointer);
var
  Data: Pointer;
  iSize : Integer;
begin
  iSize := VarArrayHighBound(Value,1)+1;
  Data  := VarArrayLock(Value);
  GetMem(Ptr, iSize);
  try
    Move(Data^, Ptr^, iSize);
  finally
    VarArrayUnlock(Value);
  end;
end;


// this is old way of doing it.  see ComponentToVariant
function ComponentToVar(Component: TComponent): String;
var
  BinStream:TMemoryStream;
  StrStream: TStringStream;
  s: string;
begin
  BinStream := TMemoryStream.Create;
  try
    StrStream := TStringStream.Create(s);
    try
      BinStream.WriteComponent(Component);
      BinStream.Seek(0, soFromBeginning);

      ObjectBinaryToText(BinStream, StrStream);
      StrStream.Seek(0, soFromBeginning);
      Result:= StrStream.DataString;
    finally
      StrStream.Free;
    end;
  finally
    BinStream.Free
  end;
end;

function VarToComponent(Value: String): TComponent;
var
  StrStream:TStringStream;
  BinStream: TMemoryStream;
begin
  StrStream := TStringStream.Create(Value);
  try
    BinStream := TMemoryStream.Create;
    try
      ObjectTextToBinary(StrStream, BinStream);
      BinStream.Seek(0, soFromBeginning);
      Result := BinStream.ReadComponent(nil);

    finally
      BinStream.Free;
    end;
  finally
    StrStream.Free;
  end;
end;

////////////////////////////////////////////////////////////
// MED: 02-01-01
///////////////////////////////////////////////////////////
function ComponentToVariant(Component: TComponent):Variant;
var
  BinStream: TMemoryStream;
  Data: Pointer;
begin
  BinStream := TMemoryStream.Create;
  try
    BinStream.WriteComponent(Component);
    Result := VarArrayCreate([0,BinStream.Size-1],varByte);
    Data := VarArrayLock(Result);
    try
      Move(BinStream.Memory^, Data^, BinStream.Size);
    finally
      VarArrayUnlock(Result);
    end;
  finally
    BinStream.Free;
  end;
end;

// MED: 02-01-01
///////////////////////////////////////////////////////////
function VariantToComponent(Value: Variant): TComponent;
var
  BinStream: TMemoryStream;
  Data: Pointer;
begin
  BinStream := TMemoryStream.Create;
  try
    Data := VarArrayLock(Value);
    try
      BinStream.WriteBuffer(Data^, VarArrayHighBound(Value,1)+1);
    finally
      VarArrayUnlock(Value);
    end;
    BinStream.Seek(0, soFromBeginning);
    Result := BinStream.ReadComponent(nil);
  finally
    BinStream.Free;
  end;
end;

////////////////////////////////////////////////////////////////////////
// MED: 02-01-01
///////////////////////////////////////////////////////////
procedure VariantToStream(V: array of Variant; var M: TMemoryStream);
var
  BuffPtr    : Pointer;
  bSkip         : Boolean;
  sType,
  sSize         : String;
  iType, i,iLow,
  iSize, iHigh  : Integer;
  strVal        : String;
  intVal        : Integer;
  douVal        : Double;
  curVal        : Currency;
  sinVal        : Single;
  datVal        : TDate;
  booVal        : WordBool;
  smaVal        : SmallInt;
  newV          : Variant;
begin
  iSize     := 0;
  newV      := VarArrayof(V);


  if (varType(newV) AND varTypeMask) = varEmpty then
    exit;

  //  If (varType(newV) = varEmpty) then    exit;

  iLow      := VarArrayLowBound(newV, 1);
  iHigh     := VarArrayHighBound(newV,1);
  VarArrayLock(newV);
  Try
    For i := iLow to iHigh do
    begin
      bSkip   := FALSE;
      BuffPtr := nil;
      iType   := (varType(newV[i]) AND varTypeMask);
      Case iType of
        varOleStr:
          begin
            strVal := VarToStr(newV[i]);iSize := length(strVal);BuffPtr := pointer(strVal);
          end;
        varInteger:
          begin
            intVal := newV[i]; iSize := 8;  BuffPtr := @intVal;
          end;
        varCurrency:
          begin
            curVal := newV[i]; iSize := 8;  BuffPtr := @curVal;
          end;
        varDouble:
          begin
            douVal := newV[i]; iSize := 8; BuffPtr := @douVal;
          end;
        varDate:
          begin
            datVal  := newV[i]; iSize := 8;    BuffPtr := @datVal;
          end;
        varSingle:
          begin
            sinVal  := newV[i]; iSize := 8;  BuffPtr := @sinVal;
          end;
        varBoolean:
          begin
            booVal  := newV[i]; iSize := 2;    BuffPtr := @booVal;
          end;
        varSmallInt:
          begin
            smaVal  := newV[i]; iSize := 8; BuffPtr := @smaVal;
          end;
      Else
        begin
          //ShowMessage('VariantToStream: Unsupported type');
          bSkip := TRUE;
        end;
      End;

      if not bSkip then
      begin
        sSize := IntToHex(iSize, 8);   M.Write(PChar(sSize)^, 8);
        sType := IntToHex(iType, 2);   M.Write(PChar(sType)^, 2);
        M.Write(BuffPtr^, iSize);
      end;

    end;
  finally
    VarArrayUnlock(newV);
  end;
end;

procedure StreamToVariant(M: TMemoryStream; var V: Variant);

  function SubStr(const cString:String; nStart,nEnd: Integer): String;
  begin
	  Result := Copy(cString, nStart, nEnd);
  end;
var
  nRead, ToRead,
  iStreamSize,iA: Integer;
  varMem,
  BuffPtr       : Pointer;
  iType         : integer;
  strVal        : String;
  A             : Variant;
begin
  VarClear(V);
//  V          := varNull;
  A          := VarArrayCreate([0,0], varVariant);
  BuffPtr    := nil;
  nRead      := 0;
  iStreamSize:= M.Size - M.Position ;
  iA         := 0;

  Try
    GetMem(BuffPtr, 11);
    Repeat
      VarArrayRedim(A, iA);
      varMem := nil;
      nRead := nRead + M.Read( buffPtr^, 8);
      if nRead > 0 then
      begin
        ToRead := StrToInt('$'+SubStr(PChar(buffPtr),1 ,8));
        nRead := nRead + M.Read( buffPtr^, 2);   // datatype
        iType := TVarType(StrToInt('$'+SubStr(PChar(buffPtr),1,2)));
        Try
          if ToRead > 0 then
          begin
            varMem := AllocMem(ToRead+1);
            nRead := nRead + M.Read( varMem^, ToRead ); // Data
          end;

          Case iType of
            varOleStr:
            begin
              strVal := pchar(varMem);
              A[iA]  := strVal;
              //  V  := String(varMem); //<--this does not terminate the string-it becomes long!
            end;
            varInteger : A[iA] := Integer(varMem^);
            varCurrency: A[iA] := Currency(varMem^);
            varDouble  : A[iA] := Double(varMem^);
            varDate    : A[iA] := TDate(varMem^);
            varSingle  : A[iA] := Single(varMem^);
            varBoolean : A[iA] := Boolean(varMem^);
            varSmallInt: A[iA] := SmallInt(varMem^);
          Else
            A[iA] := varEmpty;
          End;

        finally
          if varMem <> nil then
          begin
            FreeMem(varMem);
          end;
        end;
      end;
      inc(iA);
    Until ( (nRead = iStreamSize)); // and (ToRead = 0) );
  Finally
    FreeMem(BuffPtr);
  End;
  VarCopy( V, A);
end;

end.
